HDU 1069 Monkey and Banana / ZOJ 1093 Monkey and Banana (最长路径)

Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

Http

HDU:https://vjudge.net/problem/HDU-1069
ZOJ:https://vjudge.net/problem/ZOJ-1093

Source

最长路径

题目大意

给出若干个三维块,每一种三维块都有无数个。一个块能叠在另一块上当且仅当其边长能严格小于那一块。现在求能叠起来的最高高度

解决思路

对于每一个块,我们把其拆成三个二维矩形,并附带一个权值,矩形的长和宽分别是块的两个棱长,而附带的权值就是剩余的棱长。然后我们枚举每一对矩形i,j,看一看j是否能叠在i上,如果可以,则连边i->j,权值就是矩形j的附加权值。
相信你已经看出来了,这里我们要求的就是这个图中的最长路。
但是因为起点没有固定,所以我们建立一个超级起点0,连上所有的矩形,边权就是矩形的附加权值。
话说本来想用本题练一练Dijkstra+Heap的,但后来发现求最长路时并不满足先出的一定不再修改(为什么呢?看看样例一你就明白了),于是变成了Dijkstra+Heap+允许重入队,就等于spfa+Heap了。。。

代码

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<queue>
using namespace std;

const int maxN=40*4;
const int maxM=maxN*maxN*2;
const int inf=2147483647;

class Queue_Data//优先队列中的元素,u是点,dist是权值
{
public:
    int u,dist;
};

bool operator < (Queue_Data A,Queue_Data B)
{
    return A.dist<B.dist;
}

class Edge
{
public:
    int u,v,w;
};

int n,m;
int cnt;
int Node[maxN];
int Head[maxN];
int Next[maxM];
Edge E[maxM];
int Dist[maxN];
bool vis[maxN];
int Cube[maxN][4];
priority_queue<Queue_Data> Q;//用优先队列模拟堆

void Add_Edge(int u,int v,int w);

int main()
{
    int cas=0;
    while (cin>>n)
    {
        if (n==0)
            break;
        cnt=0;
        memset(Head,-1,sizeof(Head));
        for (int i=1;i<=n;i++)
        {
            int a,b,c;
            scanf("%d%d%d",&a,&b,&c);
            if (b<a)//为了方便后面比较,我们这里保证a<=b<=c
                swap(a,b);
            if (c<a)
                swap(a,c);
            if (c<b)
                swap(b,c);
            Cube[i][1]=a;//Cube[i][1]和Cube[i][2]分别是矩形的长和宽,并且保证Cube[i][1]<=Cube[i][2],Cube[i][3]就是矩形的附加权值(即高度)
            Cube[i][2]=b;
            Cube[i][3]=c;

            Cube[i+n][1]=b;
            Cube[i+n][2]=c;
            Cube[i+n][3]=a;

            Cube[i+n+n][1]=a;
            Cube[i+n+n][2]=c;
            Cube[i+n+n][3]=b;
        }
        /*
        for (int i=1;i<=n*3;i++)
            cout<<Cube[i][1]<<" "<<Cube[i][2]<<endl;
        cout<<endl;
        //*/
        for (int i=1;i<=n*3;i++)
            for (int j=1;j<=n*3;j++)
                if ((Cube[i][1]>Cube[j][1])&&(Cube[i][2]>Cube[j][2]))//因为上面已经保证了Cube[i][1]<=Cube[i][2]所以这里简化了判断
                    Add_Edge(i,j,Cube[j][3]);
        for (int i=1;i<=n*3;i++)//因为不知道起点,所以都连上超级起点0,或者你也可以把所有点的初值都置好然后全部丢入优先队列
            Add_Edge(0,i,Cube[i][3]);
        /*
        for (int i=1;i<=cnt;i++)
            cout<<E[i].u<<" "<<E[i].v<<" "<<E[i].w<<endl;
        //*/
        memset(vis,0,sizeof(vis));
        memset(Dist,0,sizeof(Dist));
        Q.push((Queue_Data){0,0});
        int Ans=0;
        do//求解最长路
        {
            int u=Q.top().u;
            int di=Q.top().dist;
            Q.pop();
            if (vis[u]==1)
                continue;
            vis[u]=1;
            //cout<<"take:"<<u<<" "<<di<<endl;
            Ans=max(Ans,di);//一边求就一边更新答案
            for (int i=Head[u];i!=-1;i=Next[i])
            {
                int v=E[i].v;
                if (di+E[i].w>Dist[v])
                {
                    vis[v]=0;//这里要允许重入队
                    Dist[v]=di+E[i].w;
                    Q.push((Queue_Data){v,Dist[v]});
                }
            }
        }
        while (!Q.empty());
        /*
        for (int i=1;i<=n*3;i++)
            cout<<Dist[i]<<" ";
        cout<<endl;
        //*/
        printf("Case %d: maximum height = %dn",++cas,Ans);//注意输出格式
    }
    return 0;
}

void Add_Edge(int u,int v,int w)
{
    cnt++;
    Next[cnt]=Head[u];
    Head[u]=cnt;
    E[cnt].u=u;
    E[cnt].v=v;
    E[cnt].w=w;
    return;
}

为什么这一道题和上一题一样也在[kuangbin带你飞]的专题十二 基础DP1里?我很迷茫……
可能最短路径硬扯也能说是动态规划思想吧
此处输入图片的描述

内容来源于网络如有侵权请私信删除
你还没有登录,请先登录注册
  • 还没有人评论,欢迎说说您的想法!